//=========================================
// Wrapping a height field on a sphere
// (c) 2000 Gilles Tran tran@inapg.inra.fr
//-----------------------------------------
// This demo file shows an example of wrapping a height field on a sphere

#version unofficial Megapov 0.4; // change this depending on your isosurface-aware version
#include "colors.inc"
#include "textures.inc"
#include "metals.inc"

// ----------------------------------------
camera
{
  location  <0.0, 0.5, -4.0>
  direction 1.5*z
  right     4/3*x
  look_at   <0.0, 0.0,  0.0>
}
                            
background{color rgb 1}                            
light_source{<1000,1000,-1000> color rgb 1}

// ----------------------------------------
// text : WHITE letters on BLACK background     

// First we declare a function with the map_type 1 (spherical) mapping

#declare hftext=function{pigment{image_map{png "hftext.png" map_type 1 interpolate 2}}}

// Now the isosurface
#declare rs=0.3; // try several rs values <1; the higher it is the higher is the text
isosurface{
        function{x*x+y*y+z*z + rs - hftext(x,y,z)*rs}
        contained_by{sphere{0,1}}
        eval
        max_gradient 150 // <--- important- adjust to your picture otherwise strange things happen
        threshold 1
        texture{
                onion // a spherical pattern
                texture_map{
//                [0 T_Silver_1B][0.85 T_Silver_1B][0.85 T_Gold_2C][1 T_Gold_2C] // nice but slow
                [0 pigment{Red}][0.85 pigment{Red}][0.85 pigment{SkyBlue}][1 pigment{SkyBlue}]   // quick
                }
        
        }
        rotate y*-65
        
}
